<template>
    <div>
        <div id="action" class="uk-margin-top uk-flex uk-flex-center">
            <div v-if="isAfficherBoutonDetailVide()">
                <button
                    class="uk-button uk-button-default"
                    @click="afficherErreurTypeVide()"
                >
                    Détail
                </button>
            </div>

            <div v-if="isAfficherBoutonDetailLibertes()">
                <button class="uk-button uk-button-default">
                    Détail
                </button>
                <div uk-dropdown="mode: click">
                    Les exercices pour compter les libertés n'ont qu'une
                    situation initiale.
                </div>
            </div>
            <div v-if="isAfficherBoutonDetailStandard()">
                <button
                    class="uk-button uk-button-default"
                    @click="changerEtape()"
                >
                    {{ getLibelleChangementEtape() }}
                </button>
            </div>
            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="tester()"
            >
                Tester
            </button>

            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="enregistrer()"
            >
                Enregistrer
            </button>
        </div>
        <ul class="message-erreur">
            <li v-for="erreur in erreurProbleme" :key="erreur">
                {{ erreur }}
            </li>
        </ul>
        <Goban
            ref="goban"
            :id="'gobanCaptureImage'"
            :situationInitiale="problemeCaptureImage.situationInitiale"
            :position="problemeCaptureImage.position"
            style="display: none"
        />
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
import EditionProbleme from './EditionProbleme.vue';
import Axios from '@/auth/axiosAuth';
import UIkit from 'uikit';
import { getInstanceEtatEdition } from './EtatEdition';
import Configuration from '@/classes/Configuration';
import instancierProbleme from '@/components/outils/InstanciationProbleme';
import Goban from '@/components/goban/GobanGenerationImage.vue';
import GobanGenerationImage from '@/components/goban/GobanGenerationImage.vue';
import { getNomAdresse } from '@/components/constantes/TypeDeProbleme';
import creerImageGoban from './CreationImageGoban';
@Component({
    components: { Goban }
})
export default class ActionConfiguration extends Vue {
    @Prop() idLecon: string;

    private etatEdition: any;
    private erreurProbleme: string[] = [];
    private problemeCaptureImage: Record<string, any> = [];

    $refs: {
        goban: GobanGenerationImage;
    };

    created() {
        this.etatEdition = getInstanceEtatEdition();
        this.$root.$on(
            'mettreAJourErreur',
            erreurs => (this.erreurProbleme = erreurs)
        );
    }

    private changerEtape() {
        this.erreurProbleme = [];
        this.etatEdition.erreurs = [];
        this.$root.$emit('enregistrerCommentaire');
        if (this.etatEdition.isDetail()) {
            this.etatEdition.goTo(0, -1, true);
            this.etatEdition.coupEnCours = null;
            this.$root.$emit('modifierPosition', false);
        } else {
            this.erreurProbleme = this.etatEdition.erreurs;
        }
        if (this.erreurProbleme.length === 0) {
            this.etatEdition.changerEtape();
        }
    }

    private getLibelleChangementEtape(): string {
        return this.etatEdition.isConfiguration() ? 'Détail' : 'Configuration';
    }

    private isAfficherBoutonDetailLibertes(): boolean {
        return (
            this.etatEdition.getTypeProbleme() != '' &&
            this.etatEdition.isLibertes()
        );
    }

    private isAfficherBoutonDetailVide(): boolean {
        return this.etatEdition.getTypeProbleme() == '';
    }

    private isAfficherBoutonDetailStandard(): boolean {
        return (
            this.etatEdition.getTypeProbleme() !== '' &&
            !this.etatEdition.isLibertes()
        );
    }

    private afficherErreurTypeVide() {
        this.erreurProbleme = [];
        this.erreurProbleme.push("Merci de renseigner un type d'exercice");
    }

    private tester() {
        this.erreurProbleme = [];
        this.etatEdition.erreurs = [];
        this.$root.$emit('enregistrerCommentaire');
        const configuration = this.etatEdition.getProblemeComplet();
        if (this.etatEdition.erreurs.length === 0) {
            Axios.post(
                this.getAdresseDestination(),
                response => {
                    const probleme = instancierProbleme(response.data);
                    this.$emit('afficherModalTest', probleme);
                },
                this.getDataAction(configuration)
            );
        } else {
            this.erreurProbleme = this.etatEdition.erreurs;
        }
    }

    public getDataAction(configuration: Configuration): FormData {
        const formData = new FormData();
        formData.append(
            'probleme',
            JSON.stringify(configuration.getProbleme())
        );
        const espaceDecoupage: number = configuration.getEspaceDecoupage();
        if (isNaN(espaceDecoupage)) {
            formData.append('decoupage', JSON.stringify(false));
            formData.append('espace', '0');
        } else {
            formData.append('decoupage', JSON.stringify(true));
            formData.append('espace', JSON.stringify(espaceDecoupage));
        }
        formData.append('tailleGoban', configuration.getTailleGoban());
        return formData;
    }

    private enregistrer() {
        this.erreurProbleme = [];
        this.etatEdition.erreurs = [];
        this.$root.$emit('enregistrerCommentaire');
        const configuration = this.etatEdition.getProblemeComplet();
        if (this.etatEdition.erreurs.length === 0) {
            this.problemeCaptureImage = configuration.getProbleme();
            this.problemeCaptureImage.position = {
                tailleGoban: configuration.getTailleGoban(),
                espaceDepuisHaut: 0,
                espaceDepuisBas: 0,
                espaceDepuisGauche: 0,
                espaceDepuisDroite: 0
            };
            const data: FormData = this.getDataAction(configuration);
            data.append('idLecon', this.idLecon);
            new Promise(resolve => creerImageGoban(resolve)).then(image => {
                data.append('image', image as string);
                const tags: string[] = this.etatEdition.tagsUtilise.map(
                    tag => tag.name
                );
                data.append('tags', JSON.stringify(tags));
                data.append('titre', this.etatEdition.titre);
                data.append('ordreAffichage', this.etatEdition.ordreAffichage);
                Axios.putFile(
                    this.getAdresseDestination(),
                    response => {
                        const probleme = instancierProbleme(response.data);
                        (this.$parent as EditionProbleme).setProbleme(probleme);
                        this.etatEdition.idExercice = probleme.getId();
                        UIkit.notification('Le problème a bien été enregistré');
                    },
                    data
                );
            });
        } else {
            this.erreurProbleme = this.etatEdition.erreurs;
        }
    }

    private getAdresseDestination(): string {
        return getNomAdresse(this.etatEdition.getTypeProbleme()) + '/edition/';
    }
}
</script>

<style scoped>
.message-erreur {
    color: red;
}
</style>
